@echo off
echo.
if not exist C:\usr\bin\perl.exe goto tryagain
C:\usr\bin\perl -x -S %0 %*
goto endofperl
:tryagain
perl -x -S %0 %*
goto endofperl
#!perl -w

##### Change the following to the file name extension(s)
##### of the files you wish to convert:
$FileNameMask='\.(html?|php\d?)$';

##### "$doTheSubdirs = 1" means "Do the subdirectories."
##### "$doTheSubdirs = 0" means "Do not do the subdirectories."
$doTheSubdirs = 0;

use Encode qw/encode decode/;
use Encode::Guess;
use Win32::Console::ANSI;
use Term::ANSIColor qw(:constants);
use Win32API::File qw(:ALL);

sub errorExit
 {
 my $t1=shift;
 my $t2=shift;
 my $t3=shift;
 $t1="***** MFP_DragAndDropPerlCodeOnMe ERROR $t1: $t2: $t3.\n\n";
 print LOG $t1 if(index($t2,$logFileName)<0);
 print RED,BOLD,$t1,RESET;
 exit;
 }

sub errorExit2
 {
 my $t1=shift;
 my $t2=shift;
 my $t3=shift;
 &errorExit($t1,"CAN'T OPEN FILE \"".(encode('utf8',$t2)).'"',$t3)
 }

sub printIt
 {
 my $s=shift;
 print $s;
 print LOG $s;
 }

sub printIt2
 {
 my $s=shift;
 print LOG $s;
 }

sub changesMade
 {
 &printIt("CHANGE(S) MADE TO FILE");
 &printIt2(' "'.(encode('utf8',$_)).'"');
 &printIt(": $changes \n\n");
 }

%theCodes=('&iexcl;'=>161,'&cent;'=>162,'&pound;'=>163,'&curren;'=>164,'&yen;'=>165,'&brvbar;'=>166,'&sect;'=>167,'&uml;'=>168,'&copy;'=>169,'&ordf;'=>170,'&laquo;'=>171,'&not;'=>172,'&reg;'=>174,'&macr;'=>175,'&deg;'=>176,'&plusmn;'=>177,'&sup2;'=>178,'&sup3;'=>179,'&acute;'=>180,'&micro;'=>181,'&para;'=>182,'&middot;'=>183,'&cedil;'=>184,'&sup1;'=>185,'&ordm;'=>186,'&raquo;'=>187,'&frac14;'=>188,'&frac12;'=>189,'&frac34;'=>190,'&iquest;'=>191,'&Agrave;'=>192,'&Aacute;'=>193,'&Acirc;'=>194,'&Atilde;'=>195,'&Auml;'=>196,'&Aring;'=>197,'&AElig;'=>198,'&Ccedil;'=>199,'&Egrave;'=>200,'&Eacute;'=>201,'&Ecirc;'=>202,'&Euml;'=>203,'&Igrave;'=>204,'&Iacute;'=>205,'&Icirc;'=>206,'&Iuml;'=>207,'&ETH;'=>208,'&Ntilde;'=>209,'&Ograve;'=>210,'&Oacute;'=>211,'&Ocirc;'=>212,'&Otilde;'=>213,'&Ouml;'=>214,'&times;'=>215,'&Oslash;'=>216,'&Ugrave;'=>217,'&Uacute;'=>218,'&Ucirc;'=>219,'&Uuml;'=>220,'&Yacute;'=>221,'&THORN;'=>222,'&szlig;'=>223,'&agrave;'=>224,'&aacute;'=>225,'&acirc;'=>226,'&atilde;'=>227,'&auml;'=>228,'&aring;'=>229,'&aelig;'=>230,'&ccedil;'=>231,'&egrave;'=>232,'&eacute;'=>233,'&ecirc;'=>234,'&euml;'=>235,'&igrave;'=>236,'&iacute;'=>237,'&icirc;'=>238,'&iuml;'=>239,'&eth;'=>240,'&ntilde;'=>241,'&ograve;'=>242,'&oacute;'=>243,'&ocirc;'=>244,'&otilde;'=>245,'&ouml;'=>246,'&divide;'=>247,'&oslash;'=>248,'&ugrave;'=>249,'&uacute;'=>250,'&ucirc;'=>251,'&uuml;'=>252,'&yacute;'=>253,'&thorn;'=>254,'&yuml;'=>255,'&OElig;'=>338,'&oelig;'=>339,'&Scaron;'=>352,'&scaron;'=>353,'&Yuml;'=>376,'&fnof;'=>402,'&circ;'=>710,'&tilde;'=>732,'&Alpha;'=>913,'&Beta;'=>914,'&Gamma;'=>915,'&Delta;'=>916,'&Epsilon;'=>917,'&Zeta;'=>918,'&Eta;'=>919,'&Theta;'=>920,'&Iota;'=>921,'&Kappa;'=>922,'&Lambda;'=>923,'&Mu;'=>924,'&Nu;'=>925,'&Xi;'=>926,'&Omicron;'=>927,'&Pi;'=>928,'&Rho;'=>929,'&Sigma;'=>931,'&Tau;'=>932,'&Upsilon;'=>933,'&Phi;'=>934,'&Chi;'=>935,'&Psi;'=>936,'&Omega;'=>937,'&alpha;'=>945,'&beta;'=>946,'&gamma;'=>947,'&delta;'=>948,'&epsilon;'=>949,'&zeta;'=>950,'&eta;'=>951,'&theta;'=>952,'&iota;'=>953,'&kappa;'=>954,'&lambda;'=>955,'&mu;'=>956,'&nu;'=>957,'&xi;'=>958,'&omicron;'=>959,'&pi;'=>960,'&rho;'=>961,'&sigmaf;'=>962,'&sigma;'=>963,'&tau;'=>964,'&upsilon;'=>965,'&phi;'=>966,'&chi;'=>967,'&psi;'=>968,'&omega;'=>969,'&thetasym;'=>977,'&upsih;'=>978,'&piv;'=>982,'&ensp;'=>8194,'&emsp;'=>8195,'&thinsp;'=>8201,'&zwnj;'=>8204,'&zwj;'=>8205,'&lrm;'=>8206,'&rlm;'=>8207,'&ndash;'=>8211,'&mdash;'=>8212,'&lsquo;'=>8216,'&rsquo;'=>8217,'&sbquo;'=>8218,'&ldquo;'=>8220,'&rdquo;'=>8221,'&bdquo;'=>8222,'&dagger;'=>8224,'&Dagger;'=>8225,'&bull;'=>8226,'&hellip;'=>8230,'&permil;'=>8240,'&prime;'=>8242,'&Prime;'=>8243,'&lsaquo;'=>8249,'&rsaquo;'=>8250,'&oline;'=>8254,'&frasl;'=>8260,'&euro;'=>8364,'&image;'=>8465,'&weierp;'=>8472,'&real;'=>8476,'&trade;'=>8482,'&alefsym;'=>8501,'&larr;'=>8592,'&uarr;'=>8593,'&rarr;'=>8594,'&darr;'=>8595,'&harr;'=>8596,'&crarr;'=>8629,'&lArr;'=>8656,'&uArr;'=>8657,'&rArr;'=>8658,'&dArr;'=>8659,'&hArr;'=>8660,'&forall;'=>8704,'&part;'=>8706,'&exist;'=>8707,'&empty;'=>8709,'&nabla;'=>8711,'&isin;'=>8712,'&notin;'=>8713,'&ni;'=>8715,'&prod;'=>8719,'&sum;'=>8721,'&minus;'=>8722,'&lowast;'=>8727,'&radic;'=>8730,'&prop;'=>8733,'&infin;'=>8734,'&ang;'=>8736,'&and;'=>8743,'&or;'=>8744,'&cap;'=>8745,'&cup;'=>8746,'&int;'=>8747,'&there4;'=>8756,'&sim;'=>8764,'&cong;'=>8773,'&asymp;'=>8776,'&ne;'=>8800,'&equiv;'=>8801,'&le;'=>8804,'&ge;'=>8805,'&sub;'=>8834,'&sup;'=>8835,'&nsub;'=>8836,'&sube;'=>8838,'&supe;'=>8839,'&oplus;'=>8853,'&otimes;'=>8855,'&perp;'=>8869,'&sdot;'=>8901,'&lceil;'=>8968,'&rceil;'=>8969,'&lfloor;'=>8970,'&rfloor;'=>8971,'&lang;'=>9001,'&rang;'=>9002,'&loz;'=>9674,'&spades;'=>9824,'&clubs;'=>9827,'&hearts;'=>9829,'&diams;'=>9830);
$theCodes{$ASCII}=chr($theCodes{$ASCII})while(($ASCII,$UTF8)=each(%theCodes));
$UnicodeSignature="\xEF\xBB\xBF";
$0=~/.*\\(.*)/;
$logFileName=$1;
$logFileName=~s/\.\w+?$/.log/;
open(LOG,">$logFileName") or &errorExit2(1,$logFileName,$!);
print LOG $UnicodeSignature;
$count=$totalChanges=$metaTag=0;
open DIR,'-|:encoding(UTF-16LE)','cmd /U /C dir /A-D /B'.($doTheSubdirs?' /S':'');
$count=0;
foreach (<DIR>)
 {
 $_=~s`\s+$``;
 if($_=~/$FileNameMask/i)
  {
  $count++;
  $changes=0;
  my $T1=CreateFileW(encode('UCS-2le',"$_\0"),GENERIC_READ,0,[],OPEN_EXISTING,0,0);
  &errorExit2(2,$_,$^E) if $^E;
  OsFHandleOpen(IN,$T1,'r') or &errorExit2(3,$_,$!);
  $buffer=do{local $/;<IN>};
  close(IN);
  $UnicodeSignatureFound=substr($buffer,0,3) eq $UnicodeSignature;
  if($UnicodeSignatureFound)
   {
   $buffer=substr($buffer,3);
   $buffer=decode('utf8',$buffer);
   }
  else
   {
   my $T1=guess_encoding($buffer,qw/euc-jp shiftjis 7bit-jis/);
   ref($T1) or &errorExit(4,'UNABLE TO DETERMINED THE ENCODING OF FILE: '.(encode('utf8',$_)),$!);
   $T1=$T1->name;
   $buffer=decode($T1,$buffer);
   $buffer=~s/\r//g if($T1 eq 'UTF-16');
   }
  my $T2=($buffer=~s`<head>`<head>\n<meta charset="UTF-8">`i);
  $changes+=$T2;
  $metaTag+=$T2;
  $T2=($buffer=~s`<meta charset="UTF-8">\r?\n?<meta charset="UTF-8">`<meta charset="UTF-8">`i);
  $changes-=$T2;
  $metaTag-=$T2;
  $changes+=($buffer=~s`&#(\d+);`$T1=chr($1);$T2="&#$1;\" to \"$T1";if($count{$T2}){$count{$T2}++}else{$count{$T2}=1};$T1`eg);
  while(($ASCII,$UTF8)=each(%theCodes))
   {
   my $T1=($buffer=~s`$ASCII`$UTF8`g);
   $changes+=$T1;
   $count{"$ASCII\" to \"$UTF8"}+=$T1 if($T1);
   }
  if($changes)
   {
   $buffer=encode('utf8',$buffer);
   $buffer=$UnicodeSignature.$buffer;
   $T1=encode('UCS-2le',"$_\0");
   DeleteFileW($T1);
   $T1=CreateFileW($T1,GENERIC_WRITE,0,[],OPEN_ALWAYS,0,0);
   &errorExit2(5,$_,$^E) if $^E;
   OsFHandleOpen(OUT,$T1,'w') or &errorExit2(6,$_,$!);
   print OUT $buffer;
   close(OUT);
   $totalChanges+=$changes;
   &changesMade();
   next;
   }
  else
   {
   &changesMade();
   }
  }
 }
&printIt2("$metaTag META TAG(S) ADDED.\n\n") if($metaTag);
foreach(sort{$a cmp $b} keys %count)
 {
 $T1=$_;
 $T1=encode('utf8',$T1);
 &printIt2("$count{$_} CHANGE(S) FROM \"$T1\"\n\n");
 }
&printIt($count?"TOTAL CHANGE(S) MADE TO $count \"$FileNameMask\" FILE(S): $totalChanges\n\n":"NO \"$FileNameMask\" FILES FOUND\n\n");
close(LOG);
print"FILE \"$logFileName\" CREATED.\n";

__END__
:endofperl
echo.
pause
: Downloaded from http://llbest.com/_HTMLtoUTF8.zip
